﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows;
using System.Windows.Threading;

namespace PanelBar_WPF_ItemsAutoScroll
{
	public partial class MainWindow : Window
	{
		DispatcherTimer timer = new DispatcherTimer();
		byte currentSecond = 0;
		int nextIndexToSelect = 0;
		byte autoScrollPeriod = 2;
		MainViewModel model;

		public MainWindow()
		{
			this.InitializeComponent();
			model = new MainViewModel();
			model.Children = new ObservableCollection<DataItem>(Enumerable.Range(0, 10).Select(x => new DataItem() { Header = string.Format("Item {0}", x) }));
			this.xPanelbar.ItemsSource = model.Children;
			this.DataContext = model;

			this.timer.Interval = new TimeSpan(0, 0, 1);
			this.timer.Tick += timer_Tick;
			this.timer.Start();
		}

		void timer_Tick(object sender, EventArgs e)
		{
			this.currentSecond++;
			if (this.currentSecond == this.autoScrollPeriod)
			{
				GetNextItemToSelect();
				this.currentSecond = 0;
			}
		}

		private void GetNextItemToSelect()
		{
			if (this.xPanelbar.Items.Count == nextIndexToSelect)
			{
				(this.xPanelbar.Items[0] as DataItem).IsSelected = true;
				nextIndexToSelect = 1;
			}
			else
			{
				(this.xPanelbar.Items[nextIndexToSelect] as DataItem).IsSelected = true;
				nextIndexToSelect++;
			}
		}
	}
}